package com.ruoyi.demo.utils.statistics;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.Console;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.demo.entity.AttentionPoolStatistics;
import com.ruoyi.demo.mapper.AttentionPoolDao;
import com.ruoyi.demo.mapper.AttentionPoolStatisticsDao;
import com.ruoyi.demo.mapper.BusinessOpportunitiesDao;
import com.ruoyi.demo.mapper.FollowUpDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.UUID;

@Component
public class AttentionPoolStat {
    @Autowired
    AttentionPoolDao poolDao;
    @Autowired
    BusinessOpportunitiesDao opportunitiesDao;
    @Autowired
    FollowUpDao followUpDao;
    @Autowired
    AttentionPoolStatisticsDao statisticsDao;

    public void insert() {
        List<String> ins = poolDao.selectAllUser();
        for (int i = 0; i < ins.size(); i++) {
            String userId = ins.get(i);
            AttentionPoolStatistics statistics = new AttentionPoolStatistics();
            statistics.setStatId(IdUtil.getSnowflakeNextIdStr());
            statistics.setAttentionCount(poolDao.selectCount(userId));
            statistics.setClueCount(opportunitiesDao.selectCount(userId));
            statistics.setOnlineCount(followUpDao.selectCountByWay(userId, "线上电话"));
            statistics.setOfflineCount(followUpDao.selectCountByWay(userId, "实地考察"));
            statistics.setUserId(userId);
            statistics.setStatTime(DateUtil.date());

            //先删除旧数据，再插入新数据
            statisticsDao.delete(new LambdaQueryWrapper<AttentionPoolStatistics>().eq(AttentionPoolStatistics::getUserId, userId));
            statisticsDao.insert(statistics);

            //打印进度条
            Console.print("{}当前进度：{}/{}", '\r',  (i + 1), ins.size());
        }
    }
}
